/*
 * 11/01/2002
 *
 * ElifeMenuBar
 * Copyright (C) 2002 Vouriot Thierry
 * thierry.vouriot@free.fr
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package tvouriot.elife.menus;

import java.awt.event.*;
import javax.swing.*;
import tvouriot.elife.*;
import tvouriot.elife.images.Icons;

/** Barre de menus de Elife
 */
public class ElifeMenuBar extends JMenuBar {
    
    /** Menu item "Nouveau" */    
    public static final ElifeMenuItem mnuItemNew = new ElifeMenuItem("Nouveau",Utilities.getIcon(Icons.NEW, Elife.class),KeyEvent.VK_N);
    /** Menu item "Ouvrir" */    
    public static final ElifeMenuItem mnuItemOpen = new ElifeMenuItem("Ouvrir",Utilities.getIcon(Icons.OPEN, Elife.class),KeyEvent.VK_O);
    /** Menu item "Rcents" */    
    public static final ElifeMenu mnuRecents = new ElifeMenu("Rcents",KeyEvent.VK_R);
    /** Menu item "Effacer rcents" */    
    public static final ElifeMenuItem mnuItemClearRecents = new ElifeMenuItem("Effacer Rcents");
    /** Menu item "Fermer" */    
    public static final ElifeMenuItem mnuItemClose = new ElifeMenuItem("Fermer",Utilities.getIcon(Icons.CLOSE, Elife.class),KeyEvent.VK_F);
    /** Menu item "Fermer tout" */    
    public static final ElifeMenuItem mnuItemCloseAll = new ElifeMenuItem("Fermer Tous");
    /** Menu item "Enregistrer" */    
    public static final ElifeMenuItem mnuItemSave = new ElifeMenuItem("Enregistrer",Utilities.getIcon(Icons.SAVE, Elife.class),KeyEvent.VK_E);
    /** Menu item "Enregistrer sous" */    
    public static final ElifeMenuItem mnuItemSaveAs = new ElifeMenuItem("Enregistrer Sous",Utilities.getIcon(Icons.SAVEAS, Elife.class),KeyEvent.VK_S);
    /** Menu item "Enregistrer tout" */    
    public static final ElifeMenuItem mnuItemSaveAll = new ElifeMenuItem("Enregistrer Tous",Utilities.getIcon(Icons.SAVEALL, Elife.class),KeyEvent.VK_T);
    /** Menu item "Quitter" */    
    public static final ElifeMenuItem mnuItemExit = new ElifeMenuItem("Quitter",KeyEvent.VK_Q);
    /** Menu item "Annuler" */    
    public static final ElifeMenuItem mnuItemUndo = new ElifeMenuItem("Annuler",Utilities.getIcon(Icons.UNDO, Elife.class),KeyEvent.VK_A);
    /** Menu item "Rtablir" */    
    public static final ElifeMenuItem mnuItemRedo = new ElifeMenuItem("Rtablir",Utilities.getIcon(Icons.REDO, Elife.class),KeyEvent.VK_R);
    /** Menu item "Copier" */    
    public static final ElifeMenuItem mnuItemCopy = new ElifeMenuItem("Copier",Utilities.getIcon(Icons.COPY, Elife.class),KeyEvent.VK_C);
    /** Menu item "Couper" */    
    public static final ElifeMenuItem mnuItemCut = new ElifeMenuItem("Couper",Utilities.getIcon(Icons.CUT, Elife.class),KeyEvent.VK_U);
    /** Menu item "Coller" */    
    public static final ElifeMenuItem mnuItemPaste = new ElifeMenuItem("Coller",Utilities.getIcon(Icons.PASTE, Elife.class),KeyEvent.VK_O);
    /** Menu item "Selectionner tout" */    
    public static final ElifeMenuItem mnuItemSelectAll = new ElifeMenuItem("Slectioner Tout");
    /** Menu item "Rechercher" */    
    public static final ElifeMenuItem mnuItemFind = new ElifeMenuItem("Rechercher...",Utilities.getIcon(Icons.FIND, Elife.class),KeyEvent.VK_R);
    /** Menu item "Remplacer" */    
    public static final ElifeMenuItem mnuItemReplace = new ElifeMenuItem("Remplacer...",Utilities.getIcon(Icons.REPLACE, Elife.class),KeyEvent.VK_E);
    /** Menu item "Rechercher suivant" */    
    public static final ElifeMenuItem mnuItemFindNext = new ElifeMenuItem("Rechercher Suivant",Utilities.getIcon(Icons.FINDAGAIN, Elife.class),KeyEvent.VK_S);
    /** Menu item "Aller ligne..." */    
    public static final ElifeMenuItem mnuItemGoto = new ElifeMenuItem("Aller Ligne...",Utilities.getIcon(Icons.GOTO, Elife.class),KeyEvent.VK_L);
    /** Menu item "A propos..." */    
    public static final ElifeMenuItem mnuItemAbout = new ElifeMenuItem("A propos...",Utilities.getIcon(Icons.ABOUT, Elife.class),KeyEvent.VK_A);
    /** Menu item "Outils" */    
    public static final ElifeCheckBoxMenuItem mnuItemTools = new ElifeCheckBoxMenuItem("Panneau d'outils");
    /** Menu item "Options" */    
    public static final ElifeMenuItem mnuItemOptions = new ElifeMenuItem("Options",Utilities.getIcon(Icons.OPTIONS, Elife.class),KeyEvent.VK_O);
    /** Menu item "Barre d'outils" */    
    public static final ElifeCheckBoxMenuItem mnuItemToolbar = new ElifeCheckBoxMenuItem("Barre d'outils");
    /** Menu item "Barre de status" */    
    public static final ElifeCheckBoxMenuItem mnuItemStatusbar = new ElifeCheckBoxMenuItem("Barre de status");
    /** Menu item "Documentation" */    
    public static final ElifeMenuItem mnuItemDoc = new ElifeMenuItem("Documentation",Utilities.getIcon(Icons.HELP, Elife.class),KeyEvent.VK_D);
    
    /** Constructeur
     */    
    public ElifeMenuBar() {
        super();
        
        mnuItemUndo.setEnabled(false);
        mnuItemRedo.setEnabled(false);
        
        ElifeMenu mnuFile = new ElifeMenu("Fichier",KeyEvent.VK_F);
        ElifeMenu mnuEdit = new ElifeMenu("Edition",KeyEvent.VK_E);
        ElifeMenu mnuSearch = new ElifeMenu("Recherche",KeyEvent.VK_R);
        ElifeMenu mnuElife = new ElifeMenu("Elife",KeyEvent.VK_L);
        
        mnuItemNew.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
        mnuItemOpen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
        mnuItemClose.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W, ActionEvent.CTRL_MASK));
        mnuItemSave.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
        mnuItemExit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q, ActionEvent.CTRL_MASK));
        mnuItemUndo.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z, ActionEvent.CTRL_MASK));
        mnuItemRedo.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Y, ActionEvent.CTRL_MASK));
        mnuItemCopy.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK));
        mnuItemCut.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.CTRL_MASK));
        mnuItemPaste.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, ActionEvent.CTRL_MASK));
        mnuItemFind.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F, ActionEvent.CTRL_MASK));
        mnuItemReplace.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R, ActionEvent.CTRL_MASK));
        mnuItemFindNext.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F3,0));
        mnuItemGoto.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_G, ActionEvent.CTRL_MASK));
        mnuItemAbout.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F2,0));
        mnuItemTools.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F7,0));
        mnuItemToolbar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F8,0));
        mnuItemStatusbar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F9,0));
        mnuItemDoc.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F1,0));
        
        mnuItemNew.addActionListener(Elife.getAction("new"));
        mnuItemOpen.addActionListener(Elife.getAction("open"));
        mnuItemClearRecents.addActionListener(Elife.getAction("clearrecents"));
        mnuItemClose.addActionListener(Elife.getAction("close"));
        mnuItemCloseAll.addActionListener(Elife.getAction("closeall"));
        mnuItemSave.addActionListener(Elife.getAction("save"));
        mnuItemSaveAs.addActionListener(Elife.getAction("saveas"));
        mnuItemSaveAll.addActionListener(Elife.getAction("saveall"));
        mnuItemExit.addActionListener(Elife.getAction("exit"));
        
        mnuItemUndo.addActionListener(Elife.getAction("undo"));
        mnuItemRedo.addActionListener(Elife.getAction("redo"));
        
        mnuItemCut.addActionListener(Elife.getAction("cut"));
        mnuItemCopy.addActionListener(Elife.getAction("copy"));
        mnuItemPaste.addActionListener(Elife.getAction("paste"));
        mnuItemSelectAll.addActionListener(Elife.getAction("selectall"));
        
        mnuItemGoto.addActionListener(Elife.getAction("goto"));
        mnuItemFind.addActionListener(Elife.getAction("find"));
        mnuItemFindNext.addActionListener(Elife.getAction("findnext"));
        mnuItemReplace.addActionListener(Elife.getAction("replace"));
        
        mnuItemTools.addActionListener(Elife.getAction("tools"));
        mnuItemAbout.addActionListener(Elife.getAction("about"));
        mnuItemOptions.addActionListener(Elife.getAction("options"));
        mnuItemToolbar.addActionListener(Elife.getAction("toolbar"));
        mnuItemStatusbar.addActionListener(Elife.getAction("statusbar"));
        mnuItemDoc.addActionListener(Elife.getAction("doc"));
        
        mnuFile.add(mnuItemNew);
        mnuFile.add(mnuItemOpen);
        mnuFile.add(mnuRecents);
        mnuFile.add(mnuItemClearRecents);
        mnuFile.add(Elife.isFlatMenus() ? new ElifeMenuSeparator() : new JPopupMenu.Separator());
        mnuFile.add(mnuItemClose);
        mnuFile.add(mnuItemCloseAll);
        mnuFile.add(Elife.isFlatMenus() ? new ElifeMenuSeparator() : new JPopupMenu.Separator());
        mnuFile.add(mnuItemSave);
        mnuFile.add(mnuItemSaveAs);
        mnuFile.add(mnuItemSaveAll);
        mnuFile.add(Elife.isFlatMenus() ? new ElifeMenuSeparator() : new JPopupMenu.Separator());
        mnuFile.add(mnuItemExit);
        
        mnuEdit.add(mnuItemUndo);
        mnuEdit.add(mnuItemRedo);
        mnuEdit.add(Elife.isFlatMenus() ? new ElifeMenuSeparator() : new JPopupMenu.Separator());
        mnuEdit.add(mnuItemCopy);
        mnuEdit.add(mnuItemCut);
        mnuEdit.add(mnuItemPaste);
        mnuEdit.add(Elife.isFlatMenus() ? new ElifeMenuSeparator() : new JPopupMenu.Separator());
        mnuEdit.add(mnuItemSelectAll);
        
        mnuSearch.add(mnuItemFind);
        mnuSearch.add(mnuItemReplace);
        mnuSearch.add(mnuItemFindNext);
        mnuSearch.add(mnuItemGoto);
        
        mnuElife.add(mnuItemTools);
        mnuElife.add(mnuItemToolbar);
        mnuElife.add(mnuItemStatusbar);
        mnuElife.add(Elife.isFlatMenus() ? new ElifeMenuSeparator() : new JPopupMenu.Separator());
        mnuElife.add(mnuItemOptions);
        mnuElife.add(mnuItemDoc);
        mnuElife.add(mnuItemAbout);
        
        this.add(mnuFile);
        this.add(mnuEdit);
        this.add(mnuSearch);
        this.add(mnuElife);
        
        loadRecents();
    }
    
    /** Ajout des menuitems pour les fichiers rcents
     */    
    public static void loadRecents() {
        mnuRecents.removeAll();
        String r = "none";
        int i;
        for (i=0; (r != null) && (!r.trim().equals("")); i++) {
            r = Elife.getProperty("recent."+i);
            if (r != null) {
                ElifeMenuItem item = new ElifeMenuItem(r);
                item.addActionListener(Elife.getAction("recent"));
                mnuRecents.add(item);
            }
        }  
        if (i == 1) {
            ElifeMenuItem item = new ElifeMenuItem("Pas de fichiers rcents");
            item.setEnabled(false);
            mnuRecents.add(item);
        }
    }
}

